<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Отправить заявку"
        :is-loading="isLoading"
        data-qa="requestExecutionModal"
        @submit="onSubmitHandler"
      >
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.signerInitiator"
              label="Инициатор"
              data-qa="signerInitiator"
              :readonly="true"
            />
          </div>
          <div class="col-xs-6">
            <ObDatePicker
              v-model="formData.signingDate"
              label="Дата и время"
              :is-time="true"
              :readonly="true"
              data-qa="datetime"
            />
          </div>
        </div>
        <ObTextarea
          v-model="formData.signingReason"
          label="Комментарий"
          placeholder="Введите комментарий"
          data-qa="reason"
        />
        <template v-if="order.species === 'AUTO'">
          <div class="title">Загрузите подписанную заявку</div>
          <div class="upload-list">
            <div class="upload-list__item">
              <span>1. Скачайте и подпишите заявку</span>
              <button
                data-qa="btnUploadList"
                class="upload-list__button"
                @click="downloadTemplate"
              >
                <i class="icon download" />
                <span>Скачать шаблон заявки</span>
              </button>
            </div>
            <div class="upload-list__item">2. Загрузите подписанную заявку, и другие сопутствующие документы:</div>
          </div>
          <ObUploader
            ref="uploader"
            data-qa="uploader"
            :upload-method="uploadMethod"
            @change="onUploadHandler"
          />
        </template>
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { tokenData } from '@/tokenData'
import {required, requiredIf} from 'vuelidate/lib/validators'

export default {
  name: 'OrderRequestExecutionModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObTextarea,
    ObDatePicker,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({
      userFullName: 'user/fullName'
    }),
    formModel () {
      let _self = this
      return {
        signerInitiator: {
          value: '',
          validator: {
            required
          }
        },
        signingReason: {
          value: ''
        },
        statement_uuid: {
          value: '',
          validator: {
            required: requiredIf(function () {
              return Boolean(_self.order?.species === 'AUTO')
            })
          }
        },
        signingDate: {
          value: () => new Date(),
          exclude: true
        }
      }
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  watch: {
    'formData.statement_uuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async afterInitForm () {
      this.formData.signerInitiator = this.userFullName
    },
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.statement_uuid = null
        return
      }

      this.formData.statement_uuid = data.uuid
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true
        data.signerUserUuid = tokenData.user_uuid
        this.order.species !== 'AUTO'
          ? await api.orderProcess.requestExecutionNotAuto({ subOrder: this.order, data })
          : await api.orderProcess.requestExecution({ uuid: this.order.uuid, data })
        this.$emit('on-submitted')
        this.$notification({
          type: 'system_notification_success',
          message: 'Заявка отправлена'
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось отправить заявку'
        })
      } finally {
        this.isLoading = false
      }
    },
    async downloadTemplate () {
      try {
        this.isLoading = true
        await api.orderProcess.getOrderRequestTemplate({ uuid: this.order.uuid })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isLoading = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }

    .upload-list {
      margin-bottom: 15px;
      &__item {
        display: flex;
        align-items: center;
        @include font-mixin(16px, 20px, 400, $color-grey-label);
      }
      &__item + .upload-list__item {
        margin-top: 10px;
      }
      &__button {
        display: flex;
        align-items: center;
        border: none;
        margin-left: 10px;
        background-color: transparent;
        outline: none;
        cursor: pointer;
        color: $color-blue-navy-blue;
        @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
        .icon {
          font-size: 15px;
        }
        span {
          margin-left: 7px;
        }
      }
    }
  }
</style>
